### OWASP Top Ten
#### Open Web Application Security Project (OWASP)
- [OWASP 2017 wiki](https://www.owasp.org/index.php/Category:OWASP_Top_Ten_2017_Project)
- [OWASP Cheatsheets Index](https://github.com/OWASP/CheatSheetSeries/blob/master/Index.md)
- Based on: [OWASP Risk Rating Methodology](https://www.owasp.org/index.php/OWASP_Risk_Rating_Methodology) & aligned with: [Common Weakness Enumeration](https://cwe.mitre.org/)
- Formalised in: [ASVS Project](https://www.owasp.org/index.php/Category:OWASP_Application_Security_Verification_Standard_Project)

See also: 7 Pernicious Kingdoms from CWE (Common Weakness Enumeration: https://cwe.mitre.org/data/definitions/700.html)

| 2013                                               | 2017                                             |
|----------------------------------------------------|--------------------------------------------------|
| A1 - Injection                                     | A1 - Injection                                   |
| A2 - Broken Authentication and Session Management  | A2 - Broken Authentication                       |
| A3 - XXS (Cross-Site Scripting)                    | A3 - Sensitive Data Exposure                     |
| A4 - Insecure Direct Object References             | A4 - XML External Entities (NEW)                 |
| A5 - Security Misconfiguration                     | A5 - Broken Access Control                       |
| A6 - Sensitive Data Exposure                       | A6 - Security Misconfiguration                   |
| A7 - Missing Function Level Access Control         | A7 - XSS (Cross-Site Scripting)                  |
| A8 - CSRF (Cross-Site Request Forgery) (DROPPED)   | A8 - Insecure Deserialisation (NEW)              |
| A9 - Using Components With Known Vulnerabilities   | A9 - Using Components With Known Vulnerabilities |
| A10 - Unvalidated Redirects and Forwards (DROPPED) | A10 - Insufficient Logging and Monitoring (NEW)  |
